Subject: [6tisch] Fw: CoAP ACK vs. MAC ACK in softcell negotiation procedure

From: Qin Wang <[email-masked]>
Date: Wed, 9 Jul 2014 13:18:43 -0700

On Thursday, July 10, 2014 4:02 AM, Qin Wang <[email-masked]> wrote:

Hi all,

I'm not sure about the softcell negotiation procedure example in coapie draft, particularly the "Acknowledgement". Here is the sequence diagram in the draft.

nodeA   nodeB
     |          |
     +------> | IEEE802.15.4e type: DATA
     | POST |        CoAP Header: POST (T=CON)
     |          |           Uri-Path: "6t/6/ng"
     |          |            Payload: CBOR(
     |          |                        Opcode=RESERVATION,
     |          |                        RequiredBW,
     |          |                        SlotframeID,
     |          |                        TrackID,
     |          |                        NumOfCandidate,
     |          |                        CandidateList
     |          |                     )
     |          |
     |<------ + IEEE802.15.4e type: ACK
     |          |
     |<------ + IEEE802.15.4e type: DATA
     | 2.04   |        CoAP Header: 2.04 Changed (T=CON, Code=2.04)
     |          |            Payload: CBOR(
     |          |                        NumOfCells,
     |          |                        ResultedCells
     |          |                     )
     |          |
     +------->| IEEE802.15.4e type: ACK
     |          |

Since T=CON in both POST message and its Response message, I think, besides MAC ACKs which are in lower layer, there must be CoAP ACKs correspondingly. Right? Maybe, CoAP message from nodeB to nodeA should be a CoAP ACK message. i.e.
       
nodeA   nodeB
     |          |
     +------> | IEEE802.15.4e type: DATA
     | POST |        CoAP Header: POST (T=CON)
     |          |           Uri-Path: "6t/6/ng"
     |          |            Payload: CBOR(
     |          |                        Opcode=RESERVATION,
     |          |                        RequiredBW,
     |          |                        SlotframeID,
     |          |                        TrackID,
     |          |                        NumOfCandidate,
     |          |                        CandidateList
     |          |                     )
     |          |
     |<------ + IEEE802.15.4e type: ACK
     |          |
     |<------ + IEEE802.15.4e type: DATA
     | 2.04   |        CoAP Header: 2.04 Changed (T=ACK, Code=2.04)
     |          |            Payload: CBOR(
     |          |                        NumOfCells,
     |          |                        ResultedCells
     |          |                     )
     |          |
     +------->| IEEE802.15.4e type: ACK
     |          |

What do you think?

Thanks
Qin

---

From: Michael Richardson <[email-masked]>
Date: Wed, 09 Jul 2014 17:32:44 -0400

Fixed diagram.  Your editor tried to do this in non-breaking spaces, but the
letters are still proportional.  You need to use a fixed width
non-proportional font, i.e. ASCII.

https://gist.github.com/mcr/6cd49b65865888ce8d3f

        nodeA   nodeB
        |          |
        +--------->| IEEE802.15.4e type: DATA
        |   POST   |        CoAP Header: POST (T=CON)
        |          |           Uri-Path: "6t/6/ng"
        |          |            Payload: CBOR(
        |          |                        Opcode=RESERVATION,
        |          |                        RequiredBW,
        |          |                        SlotframeID,
        |          |                        TrackID,
        |          |                        NumOfCandidate,
        |          |                        CandidateList
        |          |                     )
        |          |
        |<-------- + IEEE802.15.4e type: ACK
        |          |
        |<-------- + IEEE802.15.4e type: DATA
        |   2.04   |        CoAP Header: 2.04 Changed (T=CON, Code=2.04)
        |          |            Payload: CBOR(
        |          |                        NumOfCells,
        |          |                        ResultedCells
        |          |                     )
        |          |
        +--------->| IEEE802.15.4e type: ACK
        |          |

-- 
Michael Richardson <[email-masked]>, Sandelman Software Works
 -= IPv6 IoT consulting =-

---

From: Michael Richardson <[email-masked]>
Date: Wed, 09 Jul 2014 17:36:13 -0400

I think that the two diagrams are identical, except for:

vs:

Sadly, I don't understand enough about CoAP to comment on the issue,
I just wanted to make sure that I understood the question properly.

---

From: Thomas Watteyne <[email-masked]>
Date: Wed, 9 Jul 2014 14:45:07 -0700

Michael,
Thanks for fixing the formatting.

Qin,
I believe this is a typo, and that the response packet should be marked
"T=ACK" rather than "T=CON". This would be equivalent to Figure 17 in
http://tools.ietf.org/html/rfc7252#appendix-A.

Thomas

On Wed, Jul 9, 2014 at 2:36 PM, Michael Richardson <[email-masked]>
wrote:

> _______________________________________________
> 6tisch mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/6tisch
>
>

---

From: Qin Wang <[email-masked]>
Date: Thu, 10 Jul 2014 07:48:36 -0700

Thanks Michael and Thomas.

I will fix it.

Qin

On Thursday, July 10, 2014 5:45 AM, Thomas Watteyne <[email-masked]> wrote:

Michael,

Qin,
I believe this is a typo, and that the response packet should be marked "T=ACK" rather than "T=CON". This would be equivalent to Figure 17 in http://tools.ietf.org/html/rfc7252#appendix-A.

Thomas

---

From: Carsten Bormann <[email-masked]>
Date: Thu, 10 Jul 2014 17:36:37 +0200

> I just wanted to make sure that I understood the question properly.

I’m a bit behind on this list.
Indeed, if you want to avoid sending separate messages for acknowledgements, you piggy-back the response on the (ACK-type) acknowledgement for the (CON-type) request.
(See section 5.2.1 of RFC 7252, Figure 4, Figure 16, …).

Grüße, Carsten

---

From: Qin Wang <[email-masked]>
Date: Thu, 10 Jul 2014 08:50:51 -0700

Hi Carsten,

Thank you very much for your input. Now, we do it exactly as what you suggested.

Regards
Qin

On Thursday, July 10, 2014 11:37 PM, Carsten Bormann <[email-masked]> wrote:

Grüße, Carsten